package main

import (
	"database/sql"
	_ "github.com/mattn/go-sqlite3"
)

var db *sql.DB

func DBInit(path string) error {
	var err error
	if db, err = sql.Open("sqlite3", path); err != nil {
		return err
	}

	return nil
}

func DBCreate() error {
	_, err := db.Exec(`
CREATE TABLE IF NOT EXISTS products (id_product INTEGER NOT NULL PRIMARY KEY, name TEXT NOT NULL);
CREATE TABLE IF NOT EXISTS needs (id_need INTERGER NOT NULL PRIMARY KEY, id_product INTEGER NOT NULL, quantity INTEGER NOT NULL);
CREATE TABLE IF NOT EXISTS purchases (id_purchase INTEGER NOT NULL PRIMARY KEY, id_product INTEGER NOT NULL, date DATETIME NOT NULL, quantity INTEGER NOT NULL);
`)
	return err
}

func DBClose() error {
	return db.Close()
}

func DBPrepare(query string) (*sql.Stmt, error) {
	return db.Prepare(query)
}

func DBQuery(query string, args ...interface{}) (*sql.Rows, error) {
	return db.Query(query, args...)
}

func DBExec(query string, args ...interface{}) (sql.Result, error) {
	return db.Exec(query, args...)
}

func DBQueryRow(query string, args ...interface{}) *sql.Row {
	return db.QueryRow(query, args...)
}
